//
// cwobj.cpp
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include "stdafx.h"
#include "cwobj.h"
#include "cwcard.h"

using namespace std;
using namespace CardWirth;

std::string CWObject::readString(std::istream &in)
{
	char *buf;
	dword len;
	
	in.read((char *)&len, sizeof(dword));
	if (len > 65536)
		throw FileCorruptException();
	buf = new char[len+1];
	in.read(buf, len);
	buf[len] = '\0';
	string str(buf);
	delete[] buf;
	if (in.fail())
		throw IOException();
	return str;
}

bool CWObject::readBool(std::istream &in)
{
	byte b;
	in.read((char *)&b, sizeof(byte));
	if (in.fail())
		throw IOException();
	return !(b==0);
}

byte CWObject::readByte(std::istream &in)
{
	byte b;
	in.read((char *)&b, sizeof(byte));
	if (in.fail())
		throw IOException();
	return b;
}

word CWObject::readWord(std::istream &in)
{
	word w;
	in.read((char *)&w, sizeof(word));
	if (in.fail())
		throw IOException();
	return w;
}

dword CWObject::readDword(std::istream &in)
{
	dword dw;
	in.read((char *)&dw, sizeof(dword));
	if (in.fail())
		throw IOException();
	return dw;
}
