//
// event.cpp
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include "stdafx.h"
#include "cwobj.h"
#include "event.h"

using namespace std;
using namespace boost;
using namespace CardWirth;

void Event::read(std::istream &in)
{
	ContentReader reader;
	int n_contents = readDword(in);
	if (n_contents > 65536)
		throw FileCorruptException();

	for (int j = 0; j < n_contents; j ++) {
		contents.push_back( shared_ptr<Content>(reader.read(in)) );
	}
}

void Event::dump(std::ostream &out) const
{
	for (contentlist_type::const_iterator e = contents.begin(); e != contents.end(); e ++) {
		(*e)->dump(out);
	}
}

void EventPart::read(std::istream &in)
{
	int n_events = readDword(in);
	if (n_events > 65536)
		throw FileCorruptException();

	for (int j = 0; j < n_events; j ++) {
		events.push_back( shared_ptr<Event>(new Event(in)) );
	}
}

void EventPart::dump(std::ostream &out) const
{
	for (eventlist_type::const_iterator e = events.begin(); e != events.end(); e ++) {
		(*e)->dump(out);
	}
}