#ifndef CARDWIRTH_EVENT_H_INCLUDED
#define CARDWIRTH_EVENT_H_INCLUDED


//
// event.h
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include <string>
#include <stdexcept>
#include <list>
#include <boost/shared_ptr.hpp>
#include "content.h"
#include "cwobj.h"


namespace CardWirth
{
	class Event : public CWObject 
	{
		typedef std::list< boost::shared_ptr<Content> > contentlist_type;
	public:
		Event() {};
		Event(std::istream &in) throw(IOException) { read(in); };
		void read(std::istream &in) throw(IOException);
		virtual ~Event() {};
		virtual void dump(std::ostream &out) const throw(IOException);
	protected:
		contentlist_type contents;
	};

	class EventPart : public CWObject
	{
		typedef std::list< boost::shared_ptr<Event> > eventlist_type;
	public:
		EventPart() {};
		EventPart(std::istream &in) throw(IOException) { read(in); };
		void read(std::istream &in) throw(IOException);
		virtual ~EventPart() {};
		virtual void dump(std::ostream &out) const throw(IOException);
	protected:
		eventlist_type events;
	};
}

#endif // CARDWIRTH_EVENT_H_INCLUDED
