//
// sklcalc.cpp
//
// skilllevel calcurator Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include "stdafx.h"
#include "cwlib/cwcard.h"

using namespace std;
using namespace CardWirth;

static double targetEnemy(const SkillCard &card, ostream &out)
{
	double L, D, Lp, Dp, M, P;	// x, , x, ړ, x䖃, ږ, ̑, 
	list<Motion>::const_iterator e;

	L = D = Lp = Dp = M = 0;

	for (e = card.getMotions()->begin(); e != card.getMotions()->end(); ++e) {
#include "expr1.inc"
	}

out << std::setprecision(4)
		<< "L:" << L
		<< ", D: " << D
		<< ", Lp: " << Lp
		<< ", Dp: " << Dp
		<< ", M: " << M << endl;

	for (int slv = 1; slv < 11; slv ++) {
		double t = (9.0+slv/2.0)/2.0;

		// xł𒼐ړł
		double Dp2 = Dp + Lp*t;
		if (Dp2 > 40)
			Dp2 = 40;

		P = (L*t + D + Dp2*(Dp2+1)/2)*1.1 + M;
		if (card.targetsGroup())
			P *= 4.0;
		if (card.getToSuccess() == 5)
			P *= 2.5;
		else
			P *= 1.0 + card.getToSuccess()/8.0;
		if (card.isVerbal())
			P *= 0.8;

		switch (card.getEffectType()) {
		case 0:	P *= 1.00; break;	// 
		case 1:	P *= 1.05; break;	// @
		case 2:	P *= 1.25; break;	// @I
		case 3:	P *= 0.75; break;	// I@
		}

		if (card.getBonus(0) == 10)	// 
			P += 20;
		else
			P += card.getBonus(0);

		if (card.getBonus(1) == 10)	// R
			P += 20;
		else
			P += card.getBonus(1);

		if (card.getBonus(2) == 10)	// h
			P += 30;
		else
			P += card.getBonus(2) *1.5;

		P -= 4;

out << slv << ", " << P << "; ";
		if (P/14 - slv < 1) {
			break;
		}
	}

out << endl;
	return P/14.0;
}

static double targetNothing(const SkillCard &card, ostream &out)
{
	double P = 0.0;

	if (card.getBonus(0) == 10)	// 
		P += 20;
	else
		P += card.getBonus(0);

	if (card.getBonus(1) == 10)	// R
		P += 20;
	else
		P += card.getBonus(1);

	if (card.getBonus(2) == 10)	// h
		P += 30;
	else
		P += card.getBonus(2) *1.5;

	if (card.isVerbal())
		P *= 0.8;

	P -= 4;

	return P/14.0;
}

static double targetFriend(const SkillCard &card, ostream &out)
{
	double L, D, Lp, Dp, M, P;	// x, , x, ړ, x䖃, ږ, ̑, 
	list<Motion>::const_iterator e;

	L = D = Lp = Dp = M = 0;

	for (e = card.getMotions()->begin(); e != card.getMotions()->end(); ++e) {
#include "expr2.inc"
	}

	if (Dp > 40)
		Dp = 40;

out << std::setprecision(4)
		<< "L:" << L
		<< ", D: " << D
		<< ", Lp: " << Lp
		<< ", Dp: " << Dp
		<< ", M: " << M << endl;

	for (int slv = 1; slv < 11; slv ++) {
		double t = (9.0+slv/2.0)/2.0;
		double L2 = L + Lp*1.2;
		double D2 = D + Dp*1.2;

		P = (L2*t + D2)*1.1 + M;
		if (card.targetsGroup())
			P *= 4.0;
		P *= (card.getToSuccess()+5)/10.0;
		if (card.isVerbal())
			P *= 0.8;

		switch (card.getEffectType()) {
		case 0:	P *= 1.00; break;	// 
		case 1:	P *= 1.00; break;	// @
		case 2:	P *= 1.00; break;	// @I
		case 3:	P *= 1.00; break;	// I@
		}

		if (card.getBonus(0) == 10)	// 
			P += 20;
		else
			P += card.getBonus(0);

		if (card.getBonus(1) == 10)	// R
			P += 20;
		else
			P += card.getBonus(1);

		if (card.getBonus(2) == 10)	// h
			P += 30;
		else
			P += card.getBonus(2) *1.5;

		P -= 4;

out << slv << ", " << P << "; ";
		if (P/14 - slv < 1) {
			break;
		}
	}

out << endl;
	return P/14.0;
}

bool calculateLevel(const SkillCard &card, ostream out)
{
	double lv;
	
	switch (card.getTargetType()) {
	case 0:
		lv = targetNothing(card, out);
		break;
	case 1:
		lv = targetFriend(card, out) * 0.75; 
		break;
	case 2:
		lv = targetFriend(card, out);
		break;
	case 3:
		lv = targetEnemy(card, out);
		break;
	case 4:
		if (card.targetsGroup()) {
			out << "oS: not yet implemented." << endl;
			lv = -774;
		}
		else {
			double lv1, lv2;
			lv1 = targetEnemy(card, out);
			lv2 = targetFriend(card, out);
			lv = (lv1 > lv2) ? lv1 : lv2;
		}
		break;
	}
out << std::setprecision(3) << "level: " << lv << endl;
	return false;
}

