#ifndef CARDWIRTH_MOTION_H_INCLUDED
#define CARDWIRTH_MOTION_H_INCLUDED

//
// motion.h
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include "cwcard.h"
#include <string>

namespace CardWirth
{
	class Motion : public CWObject
	{
	public:
		Motion();
		void read(std::istream &out) throw(std::runtime_error);
		virtual void init();
		void dump(std::ostream &out) const throw(std::runtime_error);
		std::string getAttrName() const;
		static std::string getAttrName(int attr) throw(std::runtime_error);
		int getAttr() const { return attr; };
		int getCategory1() const { return type1; };
		int getCategory2() const { return type2; };
		int getSustainTime() const { return round; };
		int getValue() const { return value; };
		int getValueType() const { return valueType; };

		enum Attr{all = 0, body, mental, holy, magic, fire, ice};

	protected:
		int	type1;	// 啪
		int	type2;	// 
		int	attr;	// (S=0,,,_,,,)
		int	valueType;	// 0:xΉ, 1:, 2:ől
		int	value;
		int	round;

		static const char *attrNameStr[];
	};
}

#endif // CARDWIRTH_MOTION_H_INCLUDED
