//
// winmain.cpp
//
// skilllevel calcurator Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include "stdafx.h"
#include <windows.h>
#include <shlobj.h>
#include "resource.h"
#include "cwlib/cwcard.h"
#include "sklcalc.h"

using namespace std;
using namespace CardWirth;

HINSTANCE	hAppInstance;
HICON	hMainIcon;
IMalloc *pMalloc;
static string GResult;

static BOOL CALLBACK dlgAbout(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
static BOOL CALLBACK dlgMain(HWND hWnd, UINT uMsg,WPARAM wParam,LPARAM lParam);
static void DoCalcCard(HWND hWnd);
static void DoCalcFolder(HWND hWnd);
static void DoSaveResult(HWND hWnd);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	hAppInstance = hInstance;
	if (CoGetMalloc(1, &pMalloc) != S_OK) {
		MessageBox(NULL, "CoGetMalloc() Ɏs", NULL, MB_OK | MB_ICONEXCLAMATION);
		return 255;
	}
	hMainIcon = (HICON)LoadImage(hAppInstance, MAKEINTRESOURCE(IDI_MAIN), IMAGE_ICON, 16, 16, 0);

	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, dlgMain);
}

static BOOL CALLBACK dlgMain(HWND hWnd, UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		SendMessage(hWnd, WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)(HICON)hMainIcon);
		SetWindowText(GetDlgItem(hWnd, IDC_EDIT_RESULT), "Ɍʂ\܂");
		return TRUE;
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		return TRUE;
	case WM_COMMAND:
		WORD wID = LOWORD(wParam);
		WORD wNotifyCode = HIWORD(wParam);

		switch (wID) {
		case IDCALCCARD:
			DoCalcCard(hWnd);
			return TRUE;
		case IDCALCFOLDER:
			DoCalcFolder(hWnd);
			return TRUE;
		case IDSAVERESULT:
			DoSaveResult(hWnd);
			return TRUE;
		case IDEXIT:
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			return TRUE;
		case IDABOUT:
			DialogBox(hAppInstance, MAKEINTRESOURCE(IDD_ABOUT), hWnd, dlgAbout);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

static void DoCalcCard(HWND hWnd)
{
	char szFn[MAX_PATH] = "skill*.wid";
	OPENFILENAME	ofn = {
		sizeof(OPENFILENAME), hWnd,	NULL,
		"skill*.wid", NULL, 0, 1,
		szFn, sizeof(szFn), NULL, 0,
		NULL, NULL,
		OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY,
		0, 0,
		NULL, 0,
		NULL, NULL
	};

	if (GetOpenFileName(&ofn)) {
		try {
			SkillCard card;
			ostringstream ss;
			card.readFile(szFn);
			
			ss << "[" << szFn << "]" << endl;
			card.dump(ss);
			calculateLevel(card, ss);

			ss << ends;
			GResult = ss.str();
			
			// \n  \r\n ɕϊ
			for (int i = 0; i < GResult.length(); i ++) {
				if (GResult[i] == '\n') {
					GResult.insert(i, 1, '\r');
					i ++;
				}
			}
			
			SetWindowText(GetDlgItem(hWnd, IDC_EDIT_RESULT), GResult.c_str());
		}
		catch (runtime_error &e) {
			SetWindowText(GetDlgItem(hWnd, IDC_EDIT_RESULT), e.what());
		}
	}

}

static void DoCalcFolder(HWND hWnd)
{
	char szPath[MAX_PATH];
	BROWSEINFO bif = {
		hWnd, NULL, szPath, "ViItH_IĂ", 
		BIF_RETURNONLYFSDIRS, NULL, 0, 0
	};
	LPITEMIDLIST pidl;
	if ((pidl = SHBrowseForFolder(&bif)) != NULL) {
		if (!SHGetPathFromIDList(pidl, szPath)) {
			MessageBox(hWnd, "SHGetPathFromIDList()Ɏs", NULL, MB_OK | MB_ICONEXCLAMATION);
			pMalloc->Free(pidl);
			return;
		}
		pMalloc->Free(pidl);

		string dir(szPath);
		if (dir[dir.length()] != '\\')
			dir.append("\\");
		WIN32_FIND_DATA wfd;
		HANDLE hFind;

		if ((hFind = FindFirstFile((dir+"skill*.wid").c_str(), &wfd)) == INVALID_HANDLE_VALUE) {
			MessageBox(hWnd, "Z\J[h܂", NULL, MB_OK | MB_ICONEXCLAMATION);
			return;
		}

		SkillCard card;
		ostringstream ss;
		do {
			try {
				ss << "[" << dir << wfd.cFileName << "]" << endl;
				card.readFile((dir+wfd.cFileName).c_str());
				card.dump(ss);
				calculateLevel(card, ss);
			}
			catch (runtime_error &e) {
				ss << e.what() << endl;
			}
			ss << endl;
		} while (FindNextFile(hFind, &wfd));
		FindClose(hFind);
		
		ss << ends;
		GResult = ss.str();
		
		// \n  \r\n ɕϊ
		for (int i = 0; i < GResult.length(); i ++) {
			if (GResult[i] == '\n') {
				GResult.insert(i, 1, '\r');
				i ++;
			}
		}
		SetWindowText(GetDlgItem(hWnd, IDC_EDIT_RESULT), GResult.c_str());
	}

}

static void DoSaveResult(HWND hWnd)
{
	char szFn[MAX_PATH] = "report.txt";
	OPENFILENAME	ofn = {
		sizeof(OPENFILENAME), NULL, NULL,
		"*.txt", NULL, 0, 1,
		szFn, sizeof(szFn), NULL, 0,
		NULL, NULL,
		OFN_PATHMUSTEXIST | OFN_HIDEREADONLY,
		0, 0,
		NULL, 0,
		NULL, NULL
	};

	if (GetSaveFileName(&ofn)) {
		string s(szFn);
		ofstream out(s.c_str(), ios::out | ios::trunc);
		if (out.fail()) {
			MessageBox(hWnd, (s+": J܂").c_str(), NULL, MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		out << GResult;
		if (out.fail()) {
			MessageBox(hWnd, (s+": ݃G[").c_str(), NULL, MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		out.close();
	}
}

static BOOL CALLBACK dlgAbout(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		return TRUE;
	case WM_COMMAND:
		WORD wID = LOWORD(wParam);

		switch (wID) {
		case IDOK:
			EndDialog(hWnd, IDOK);
			return TRUE;
		}
		break;
	}
	return FALSE;
}
